/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 26.08.2012
Author  : NeVaDa
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 2,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>

// Alphanumeric LCD Module functions
#include <alcd.h>

#define zero_bit 0
#define one_bit 1
#define error_bit 255
#define start_bit 254
#define repeat_bit 253

#define PULT_GR 1
#define PULT_NONE 0
#define PULT_PRESS_KEY 1
#define PULT_REPEAT_KEY 2

unsigned int tim0_ovf_cnt; //   0,    
unsigned int cnt = 0;
unsigned int sigArr[50];
unsigned int testArr[50];
unsigned char isTimeout = 0;
unsigned int pulseTime;
unsigned int sigTime = 0;
unsigned char pult_a1 = 0;
unsigned char pult_a2 = 0;
unsigned char pult_c1 = 0;
unsigned char pult_c2 = 0;
unsigned char pult_state = PULT_NONE;
unsigned char pult_bit;
unsigned char x,a,b,c,d,e,f,g,k,z=1,sw_state1;
char Disp1,Disp2,Disp3,Disp4,Disp5,Disp6,Disp7,Disp8,Disp9,Disp10;
char Dig[]={'0','1','2','3','4','5','6','7','8','9'};

//   INT0
// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
    x++;
    pulseTime = tim0_ovf_cnt * 256 + TCNT0; //   
    if (PIND.2 > 0)
    {   a++;
        sigTime = pulseTime;//    
    }
    else
    {
        if ((cnt < 100) && (sigTime > 0))
        {  b++;
            pult_bit = error_bit;
            if ((sigTime > 2100) && (sigTime < 2500) && (pulseTime > 1000) && (pulseTime < 1200))// 
            {c++;
                cnt = 0;
                pult_bit = start_bit;
				pult_state = PULT_NONE;
			}
			else if ((sigTime > 100) && (sigTime < 200))
			{ d++;
				if ((pulseTime > 350) && (pulseTime < 600))
				{  e++;
					pult_bit = one_bit;
				}
				else if ((pulseTime > 100) && (pulseTime < 200))
				{  f++;
					pult_bit = zero_bit;
				}
				else if ((pulseTime > 23000) && (pulseTime < 25000))
				{   g++;
					pult_bit = repeat_bit;
					pult_state = PULT_REPEAT_KEY;
					//SendPacketToUSB(1, 3);
				}
			}				
				
			sigArr[cnt] = sigTime;
			testArr[cnt] = pulseTime;
				
			if ((pult_bit == one_bit) || (pult_bit == zero_bit))
			{  k++;
				if ((cnt >= 1) && (cnt <= 8))
				{
					pult_a1 = (pult_a1 << 1);
					pult_a1 = (pult_a1 | pult_bit);
				}
				else if ((cnt >= 9) && (cnt <= 16))
				{
					pult_a2 = (pult_a2 << 1);
					pult_a2 = (pult_a2 | pult_bit);
				}
				else if ((cnt >= 17) && (cnt <= 24))
				{
					pult_c1 = (pult_c1 << 1);
					pult_c1 = (pult_c1 | pult_bit);
				}
				else if ((cnt >= 25) && (cnt <= 32))
				{
					pult_c2 = (pult_c2 << 1);
					pult_c2 = (pult_c2 | pult_bit);
				}
				if (cnt == 32)//  
				{
					pult_state = PULT_PRESS_KEY;
					//SendPacketToUSB(1, 3);
				}					
			}
			if (isTimeout == 0)
			{
				cnt++;
			}
			else
			{
				cnt = 0;
				isTimeout = 0;
			}
		}
		else
		{
			if (cnt > 100);
				//printf_P(PSTR("cnt > 100\n\r"));
		}
	}
		
	// 
	tim0_ovf_cnt = 0;
	TCNT0 = 0;
}

//    Timer0
// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
tim0_ovf_cnt++;
	if ((tim0_ovf_cnt > 195) && (cnt > 0))//,   IR     200  
	{
		isTimeout = 1;
		cnt = 0;
		sigTime = 0;
	}
}

void Display(unsigned int Number) //-    /**/
{
  unsigned char Num1, Num2, Num3,Num4, Num5;
  Num1=0;
  Num2=0;
  Num3=0;
  Num4=0;
  Num5=0;
  
  while (Number >= 10000) //10000
  {
  Number -= 10000;  
  Num1++; 
  }
  
  while (Number >= 1000) //1000
  {
  Number -= 1000;  
  Num2++; 
  }
  
  while (Number >= 100) //100
  {
  Number -= 100;  
  Num3++; 
  }
  
  while (Number >= 10) //10
  {
  Number -= 10;  
  Num4++; 
  }
  
  Num5 = Number; //
  Disp1 = Dig[Num1];
  Disp2 = Dig[Num2];
  Disp3 = Dig[Num3];  //
  Disp4 = Dig[Num4];  //
  Disp5 = Dig[Num5]; // 
}; 

void Display2(unsigned int Number2) //-    /**/
{
  unsigned char Num6, Num7, Num8,Num9, Num10;
  Num6=0;
  Num7=0;
  Num8=0;
  Num9=0;
  Num10=0;
  
  while (Number2 >= 10000) //10000
  {
  Number2 -= 10000;  
  Num6++; 
  }
  
  while (Number2 >= 1000) //1000
  {
  Number2 -= 1000;  
  Num7++; 
  }
  
  while (Number2 >= 100) //100
  {
  Number2 -= 100;  
  Num8++; 
  }
  
  while (Number2 >= 10) //10
  {
  Number2 -= 10;  
  Num9++; 
  }
  
  Num10 = Number2; //
  Disp6 = Dig[Num6];
  Disp7 = Dig[Num7];
  Disp8 = Dig[Num8];  //
  Disp9 = Dig[Num9];  //
  Disp10 = Dig[Num10]; // 
};

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=P State2=P State1=P State0=T 
PORTD=0x0E;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 250,000 kHz
TCCR0=0x02;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Any change
// INT1: Off
GICR|=0x40;
MCUCR=0x01;
GIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Alphanumeric LCD initialization
// Connections specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTB Bit 0
// RD - PORTD Bit 6
// EN - PORTD Bit 5
// D4 - PORTB Bit 7
// D5 - PORTB Bit 4
// D6 - PORTB Bit 5
// D7 - PORTD Bit 7
// Characters/line: 8
lcd_init(8);

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here
      if ((PIND.4==1)&&(sw_state1==1)) 
      {
         z++;
         sw_state1=0; 
         lcd_clear();
        
        
      };
      if ((PIND.4==0)&&(sw_state1==0)) sw_state1=1;
      if (z>42) z=1;
      
            
    
      switch (z) 
      {
         case 1: Display(pult_a1);
                 Display2(pult_a2);
                 lcd_gotoxy(0,0);
                 lcd_puts("a1=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" a2=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
         case 2: Display(pult_c1);
                 Display2(pult_c2);
                 lcd_gotoxy(0,0);
                 lcd_puts("c1=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" c2=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
         case 3: Display(b);
                 Display2(c);
                 lcd_gotoxy(0,0);
                 lcd_puts("b=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" c=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
         case 4: Display(d);
                 Display2(e);
                 lcd_gotoxy(0,0);
                 lcd_puts("d=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" e=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
         case 5: Display(f);
                 Display2(g);
                 lcd_gotoxy(0,0);
                 lcd_puts("f=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" g=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
         case 6: Display(k);
                 Display2(TCNT0);
                 lcd_gotoxy(0,0);
                 lcd_puts("k=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" TCNT0=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
         case 7: Display(sigArr[0]);
                 Display2(testArr [0]);
                 lcd_gotoxy(0,0);
                 lcd_puts("0=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 1=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 8: Display(sigArr [1]);
                 Display2(testArr [1]);
                 lcd_gotoxy(0,0);
                 lcd_puts("2=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 3=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 9: Display(sigArr [2]);
                 Display2(testArr [2]);
                 lcd_gotoxy(0,0);
                 lcd_puts("4=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 5=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 10: Display(sigArr [3]);
                 Display2(testArr [3]);
                 lcd_gotoxy(0,0);
                 lcd_puts("6=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 7=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 11: Display(sigArr [4]);
                 Display2(testArr [4]);
                 lcd_gotoxy(0,0);
                 lcd_puts("8=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 9=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 12: Display(sigArr [5]);
                 Display2(testArr [5]);
                 lcd_gotoxy(0,0);
                 lcd_puts("10=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 11=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 13: Display(sigArr [6]);
                 Display2(testArr [6]);
                 lcd_gotoxy(0,0);
                 lcd_puts("12=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 13=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 14: Display(sigArr [7]);
                 Display2(testArr [7]);
                 lcd_gotoxy(0,0);
                 lcd_puts("14=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 15=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 15: Display(sigArr [8]);
                 Display2(testArr [8]);
                 lcd_gotoxy(0,0);
                 lcd_puts("16=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 17=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 16: Display(sigArr [9]);
                 Display2(testArr [9]);
                 lcd_gotoxy(0,0);
                 lcd_puts("18=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 19=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 17: Display(sigArr [10]);
                 Display2(testArr [10]);
                 lcd_gotoxy(0,0);
                 lcd_puts("20=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 21=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 18: Display(sigArr [11]);
                 Display2(testArr [11]);
                 lcd_gotoxy(0,0);
                 lcd_puts("22=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 23=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 19: Display(sigArr [12]);
                 Display2(testArr [12]);
                 lcd_gotoxy(0,0);
                 lcd_puts("24=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 25=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 20: Display(sigArr [13]);
                 Display2(testArr [13]);
                 lcd_gotoxy(0,0);
                 lcd_puts("26=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 27=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 21: Display(sigArr [14]);
                 Display2(testArr [14]);
                 lcd_gotoxy(0,0);
                 lcd_puts("28=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 29=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 22: Display(sigArr [15]);
                 Display2(testArr [15]);
                 lcd_gotoxy(0,0);
                 lcd_puts("30=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 31=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 23: Display(sigArr [16]);
                 Display2(testArr [16]);
                 lcd_gotoxy(0,0);
                 lcd_puts("32=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 33=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 24: Display(sigArr [17]);
                 Display2(testArr [17]);
                 lcd_gotoxy(0,0);
                 lcd_puts("34=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 35=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 25: Display(sigArr [18]);
                 Display2(testArr [18]);
                 lcd_gotoxy(0,0);
                 lcd_puts("36=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 37=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 26: Display(sigArr [19]);
                 Display2(testArr [19]);
                 lcd_gotoxy(0,0);
                 lcd_puts("38=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 39=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 27: Display(sigArr [20]);
                 Display2(testArr [20]);
                 lcd_gotoxy(0,0);
                 lcd_puts("40=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 41=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 28: Display(sigArr [21]);
                 Display2(testArr [21]);
                 lcd_gotoxy(0,0);
                 lcd_puts("42=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 43=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 29: Display(sigArr [22]);
                 Display2(testArr [22]);
                 lcd_gotoxy(0,0);
                 lcd_puts("44=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 45=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 30: Display(sigArr [23]);
                 Display2(testArr [23]);
                 lcd_gotoxy(0,0);
                 lcd_puts("46=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 47=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 31: Display(sigArr [24]);
                 Display2(testArr [24]);
                 lcd_gotoxy(0,0);
                 lcd_puts("48=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 49=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 32: Display(sigArr [25]);
                 Display2(testArr [25]);
                 lcd_gotoxy(0,0);
                 lcd_puts("50=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 51=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 33: Display(sigArr [26]);
                 Display2(testArr [26]);
                 lcd_gotoxy(0,0);
                 lcd_puts("52=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 53=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 34: Display(sigArr [27]);
                 Display2(testArr [27]);
                 lcd_gotoxy(0,0);
                 lcd_puts("54=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 55=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 35: Display(sigArr [28]);
                 Display2(testArr [28]);
                 lcd_gotoxy(0,0);
                 lcd_puts("56=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 57=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 36: Display(sigArr [29]);
                 Display2(testArr [29]);
                 lcd_gotoxy(0,0);
                 lcd_puts("58=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 59=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 37: Display(sigArr [30]);
                 Display2(testArr [30]);
                 lcd_gotoxy(0,0);
                 lcd_puts("60=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 61=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 38: Display(sigArr [31]);
                 Display2(testArr [31]);
                 lcd_gotoxy(0,0);
                 lcd_puts("62=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 63=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 39: Display(sigArr [32]);
                 Display2(testArr [32]);
                 lcd_gotoxy(0,0);
                 lcd_puts("64=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 65=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 40: Display(sigArr [33]);
                 Display2(testArr [33]);
                 lcd_gotoxy(0,0);
                 lcd_puts("66=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 67=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 41: Display(sigArr [34]);
                 Display2(testArr [34]);
                 lcd_gotoxy(0,0);
                 lcd_puts("68=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 69=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;
                 
          case 42: Display(sigArr [35]);
                 Display2(testArr [35]);
                 lcd_gotoxy(0,0);
                 lcd_puts("70=");
                 lcd_putchar(Disp3);lcd_putchar(Disp4); lcd_putchar(Disp5);
                 lcd_puts(" 71=");
                 lcd_putchar(Disp8);lcd_putchar(Disp9); lcd_putchar(Disp10);
                 lcd_puts("  ");
                 break;                  
         
      };         
      
      
      
      
      
      
      
      }
}
